//
// MICROCHIP SOFTWARE NOTICE AND DISCLAIMER: You may use this software,
// and any derivatives created by any person or entity by or on your
// behalf, exclusively with Microchip’s products. Microchip and its
// licensors retain all ownership and intellectual property rights in
// the accompanying software and in all derivatives hereto.
//
// This software and any accompanying information is for suggestion
// only. It does not modify Microchip’s standard warranty for its
// products. You agree that you are solely responsible for testing the
// software and determining its suitability. Microchip has no obligation
// to modify, test, certify, or support the software.
//
// THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES,
// WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING, BUT NOT LIMITED TO,
// IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS
// FOR A PARTICULAR PURPOSE APPLY TO THIS SOFTWARE, ITS INTERACTION WITH
// MICROCHIP’S PRODUCTS, COMBINATION WITH ANY OTHER PRODUCTS, OR USE IN
// ANY APPLICATION.
//
// IN NO EVENT, WILL MICROCHIP BE LIABLE, WHETHER IN CONTRACT, WARRANTY,
// TORT (INCLUDING NEGLIGENCE OR BREACH OF STATUTORY DUTY), STRICT
// LIABILITY, INDEMNITY, CONTRIBUTION, OR OTHERWISE, FOR ANY INDIRECT,
// SPECIAL, PUNITIVE, EXEMPLARY, INCIDENTAL OR CONSEQUENTIAL LOSS,
// DAMAGE, FOR COST OR EXPENSE OF ANY KIND WHATSOEVER RELATED TO THE
// SOFTWARE, HOWSOEVER CAUSED, EVEN IF MICROCHIP HAS BEEN ADVISED OF THE
// // POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO THE FULLEST EXTENT
// ALLOWABLE BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL CLAIMS IN ANY
// WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT OF FEES, IF
// ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS SOFTWARE.
//
// MICROCHIP PROVIDES THIS SOFTWARE CONDITIONALLY UPON YOUR ACCEPTANCE
// OF THESE TERMS.
//


#ifndef __TYPEDEFS_H
#define __TYPEDEFS_H


//General redefines
typedef unsigned char UINT8;
typedef unsigned int UINT16;
typedef signed int INT16;
typedef unsigned long UINT32;

typedef union {
    UINT8 Val;

    struct {
        UINT8 b0 : 1;
        UINT8 b1 : 1;
        UINT8 b2 : 1;
        UINT8 b3 : 1;
        UINT8 b4 : 1;
        UINT8 b5 : 1;
        UINT8 b6 : 1;
        UINT8 b7 : 1;
    } bits;
} UINT8_VAL, UINT8_BITS;

typedef union {
    UINT16 Val;
    UINT8 v[2];

    struct {
        UINT8 LB;
        UINT8 HB;
    } byte;

    struct {
        UINT8 b0 : 1;
        UINT8 b1 : 1;
        UINT8 b2 : 1;
        UINT8 b3 : 1;
        UINT8 b4 : 1;
        UINT8 b5 : 1;
        UINT8 b6 : 1;
        UINT8 b7 : 1;
        UINT8 b8 : 1;
        UINT8 b9 : 1;
        UINT8 b10 : 1;
        UINT8 b11 : 1;
        UINT8 b12 : 1;
        UINT8 b13 : 1;
        UINT8 b14 : 1;
        UINT8 b15 : 1;
    } bits;
} UINT16_VAL, UINT16_BITS;

typedef union {
    UINT32 Val;
    UINT16 w[2];
    UINT8 v[4];

    struct {
        UINT16 LW;
        UINT16 HW;
    } word;

    struct {
        UINT8 LB;
        UINT8 HB;
        UINT8 UB;
        UINT8 MB;
    } byte;

    struct {
        UINT16_VAL low;
        UINT16_VAL high;
    } wordUnion;

    struct {
        UINT8 b0 : 1;
        UINT8 b1 : 1;
        UINT8 b2 : 1;
        UINT8 b3 : 1;
        UINT8 b4 : 1;
        UINT8 b5 : 1;
        UINT8 b6 : 1;
        UINT8 b7 : 1;
        UINT8 b8 : 1;
        UINT8 b9 : 1;
        UINT8 b10 : 1;
        UINT8 b11 : 1;
        UINT8 b12 : 1;
        UINT8 b13 : 1;
        UINT8 b14 : 1;
        UINT8 b15 : 1;
        UINT8 b16 : 1;
        UINT8 b17 : 1;
        UINT8 b18 : 1;
        UINT8 b19 : 1;
        UINT8 b20 : 1;
        UINT8 b21 : 1;
        UINT8 b22 : 1;
        UINT8 b23 : 1;
        UINT8 b24 : 1;
        UINT8 b25 : 1;
        UINT8 b26 : 1;
        UINT8 b27 : 1;
        UINT8 b28 : 1;
        UINT8 b29 : 1;
        UINT8 b30 : 1;
        UINT8 b31 : 1;
    } bits;
} UINT32_VAL;


#endif